# booleanhelper.rb
# april 9, 2011
#
# Description: Quick scale up a small model (mm size) to do boolean or lathe operations.
# This is usefull since sketchup can not work with very small faces.
# After the operations are finished you can scale your model down to get back to the original dimensions
#
# 
# This plugin was conceived by me, rene van Asperen with great help from TIG  and Thomas from
# the SketchUcation forums.
#
#
# USE OF THIS SOFTWARE IS AT YOUR OWN RISK!
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.




require 'sketchup.rb'

#=============================================================================
module Bhelper

# $booleanhelperscalefactor=1000.0

   sf = 1000
     
	if 	Sketchup.read_default('liquidsscalefactor','value') == nil
		
		
		Sketchup.write_default('liquidsscalefactor','value',sf)
		
	end	

	
class Getinfo
	
	def initialize() 

		sf = Sketchup.read_default('liquidsscalefactor','value')
	    
		prompts = ["Enter scalefactor   "]
		values = [sf]
		
		results = UI.inputbox prompts, values, "Scalefactor."
		
		return if not results
		sf_input = results
     
		Sketchup.write_default('liquidsscalefactor','value',sf_input)
      
		#UI.messagebox Sketchup.read_default('liquidsscalefactor','value')
      
	end

end


	




class Kleiner
	
	def initialize() 
	sfa = Sketchup.read_default('liquidsscalefactor','value')
	sff = sfa[0].to_f
	
	model = Sketchup.active_model

        entities = model.active_entities
        selection = model.selection

         trans = Geom::Transformation.scaling(ORIGIN, 1.0/sff)

        entities.transform_entities(trans, selection.to_a)
	#view = Sketchup.active_model.active_view
	#new_view = view.zoom_extents
	
	end
end





class Groter
	
	def initialize() 
	sfa = Sketchup.read_default('liquidsscalefactor','value', 0)
	sff = sfa[0].to_f
	
	
        
	model = Sketchup.active_model

        

        entities= model.active_entities
        selection = model.selection

        trans = Geom::Transformation.scaling(ORIGIN, sff)
        

        entities.transform_entities(trans, selection.to_a)
	
	
	
	end
end


 

#=============================================================================
if( not $booleanhelper_menu_loaded )
    sfa = Sketchup.read_default('liquidsscalefactor','value')
    sftt = sfa[0].to_f
    add_separator_to_menu("Plugins")
        new_menu = UI.menu("Plugins").add_submenu("Boolean helper")
        new_toolbar = UI::Toolbar.new("Boolean helper")
        plugins = Sketchup.find_support_file("Plugins")
        imgdir = File.join(plugins, "Booleanhelper")

        cmd = UI::Command.new("Scale down") {Bhelper::Kleiner.new() }
        cmd.small_icon = File.join(imgdir, "smaller.png")
        cmd.large_icon = File.join(imgdir, "smallerL.png")
	cmd.tooltip = ("Scale down with factor #{sftt}")
        cmd.menu_text = ("Scale down with factor #{sftt}")

    new_menu.add_item(cmd)
    new_toolbar.add_item(cmd)


        cmd = UI::Command.new("Scale up") {Bhelper::Groter.new() }
        cmd.small_icon = File.join(imgdir, "bigger.png")
        cmd.large_icon = File.join(imgdir, "biggerL.png")
	cmd.tooltip = ("Scale up with factor #{sftt}")
        cmd.menu_text = ("Scale up with factor #{sftt}")

    new_menu.add_item(cmd)
    new_toolbar.add_item(cmd)
    
    cmd = UI::Command.new("set scale factor") {Bhelper::Getinfo.new()}
	
     new_menu.add_item(cmd)
     
        new_toolbar.show

        $booleanhelper_menu_loaded = true
end 

end #module




